--[[
Author: Starinnia
RealID Toons - Add character information to the BNet alerts your RealID friends generate
$Date: 2010-06-27 01:38:34 +0000 (Sun, 27 Jun 2010) $
$Revision: 5 $
Project Version: r5
contact: codemaster2010 AT gmail DOT com

Copyright (c) 2007-2010 Michael J. Murray aka Lyte of Lothar(US)
All rights reserved unless otherwise explicitly stated.
]]

local function filter(self, event, msg, author, ...)
	--the only toast we care about is FRIEND_ONLINE
	if msg ~= "FRIEND_ONLINE" then
		return false, msg, author, ...
	end
	
	local presenceID, givenName, surname, toonName, toonID, client, fullName
	local type = strsub(event, 10)
	local info = ChatTypeInfo[type]
	local arg11 = select(9, ...)
	
	--loop through the BNet friends to determine the toon name
	for i = 1, BNGetNumFriends() do
		presenceID, givenName, surname, toonName, toonID, client = BNGetFriendInfo(i)
		fullName = givenName.." "..surname
		--double check the client too, this will prevent strangeness when SC2 is released
		if client == "WoW" and author == fullName then
			--construct the playerlink and message prefix seperately for easier debugging
			local playerlink = string.format("|HBNplayer:%s:%s:%s:%s:%s|h[%s]|h", author, 7, arg11, Chat_GetChatCategory(type), 0, author)
			local prefix = string.format(BN_INLINE_TOAST_FRIEND_ONLINE, playerlink)
			--add a message to the passed in chat frame that looks like the regular toast
			self:AddMessage(string.format("%s (%s)", prefix, toonName), info.r, info.g, info.b, info.id)
			
			--block the acual toast, it is replaced with our own
			return true, msg, author, ...
			
		--if the client is anything but WoW just return the real name
		elseif author == fullName then
			return false, msg, author, ...
		end
	end
end

ChatFrame_AddMessageEventFilter("CHAT_MSG_BN_INLINE_TOAST_ALERT", filter)

BNToastFrame:HookScript("OnShow", function()
	local topLine = BNToastFrameTopLine
	local bottomLine = BNToastFrameBottomLine
	
	--ensure that this toast is a friend coming online
	if string.match(bottomLine:GetText(), BN_TOAST_ONLINE) then
		local prefix = topLine:GetText()
		local presenceID, givenName, surname, toonName, toonID, client, fullName
		
		--loop through the BNet friends again
		for i = 1, BNGetNumFriends() do
			presenceID, givenName, surname, toonName, toonID, client = BNGetFriendInfo(i)
			fullName = string.format(BATTLENET_NAME_FORMAT, givenName, surname)
			--if its a WoW client add the toon name, otherwise only display the real name
			if client == "WoW" and prefix == fullName then
				topLine:SetFormattedText("%s (%s)", prefix, toonName)
				break
			elseif prefix == fullName then
				break
			end
		end
	end
end)
